/// <reference types="cesium" />
import { ESSceneObject, PickedInfo } from "xbsj-xe2/dist-node/xe2-base-objects";
import { Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "xbsj-xe2/dist-node/xe2-base-utils";
export declare class CzmGeoJson extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        show: boolean;
        allowPicking: boolean | undefined;
        loadFuncStr: string | undefined;
        url: string | {
            [xx: string]: any;
        } | undefined;
        stroked: boolean | undefined;
        strokeWidth: number | undefined;
        strokeWidthType: string;
        strokeColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        strokeMaterial: string | undefined;
        strokeMaterialParams: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<any>;
        strokeGround: boolean | undefined;
        filled: boolean | undefined;
        fillColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        fillMaterial: string | undefined;
        fillMaterialParams: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<any>;
        fillGround: boolean | undefined;
        imageShow: boolean | undefined;
        imageUrl: string | undefined;
        imageSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        imageAnchor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        imageOffset: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        textShow: boolean | undefined;
        textProperty: string | undefined;
        textDefaultText: string | undefined;
        textColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        textBackgroundColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        textFontFamily: string | undefined;
        textFontSize: number | undefined;
        textFontStyle: number | undefined;
        textFontWeight: number | undefined;
        textAnchor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        textOffset: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        minFeatureVisibleDistance: number;
        maxFeatureVisibleDistance: number;
        heightReference: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _loadFuncReact;
    get loadFun(): ((dataSource: Cesium.GeoJsonDataSource) => void) | undefined;
    set loadFun(value: ((dataSource: Cesium.GeoJsonDataSource) => void) | undefined);
    get loadFunChanged(): Listener<[((dataSource: import("cesium").GeoJsonDataSource) => void) | undefined, ((dataSource: import("cesium").GeoJsonDataSource) => void) | undefined]>;
    constructor(id?: string);
    static defaults: {
        show: boolean;
        allowPicking: boolean;
        url: string;
        defaultLoadFuncStr: string;
        defaultLoadFuncDocStr: string;
        data: {
            type: string;
            features: {
                type: string;
                geometry: {
                    type: string;
                    coordinates: number[];
                };
                properties: {
                    title: string;
                    "marker-symbol": string;
                    "marker-color": string;
                };
            }[];
        };
        dataMd: string;
        stroked: boolean;
        strokeWidth: number;
        strokeWidthType: string;
        strokeColor: [number, number, number, number];
        strokeMaterial: string;
        strokeMaterialParams: {};
        strokeGround: boolean;
        filled: boolean;
        fillColor: [number, number, number, number];
        fillMaterial: string;
        fillMaterialParams: {};
        fillGround: boolean;
        imageShow: boolean;
        imageUrl: string;
        imageSize: [number, number];
        imageAnchor: [number, number];
        imageOffset: [number, number];
        textShow: boolean;
        textProperty: string;
        textDefaultText: string;
        textColor: [number, number, number, number];
        textBackgroundColor: [number, number, number, number];
        textFontFamily: string;
        textFontSize: number;
        textFontWeight: string;
        textFontStyle: string;
        textAnchor: [number, number];
        textOffset: [number, number];
        strokeWidthTypes: [name: string, value: string][];
        minFeatureVisibleDistance: number;
        maxFeatureVisibleDistance: number;
        heightReferences: [name: string, value: string][];
        viewerTagsEnums: [string, string][];
    };
    getProperties(language?: string): import("xbsj-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmGeoJson {
    const createDefaultProps: () => {
        show: boolean;
        allowPicking: boolean | undefined;
        loadFuncStr: string | undefined;
        url: string | {
            [xx: string]: any;
        } | undefined;
        stroked: boolean | undefined;
        strokeWidth: number | undefined;
        strokeWidthType: string;
        strokeColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        strokeMaterial: string | undefined;
        strokeMaterialParams: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<any>;
        strokeGround: boolean | undefined;
        filled: boolean | undefined;
        fillColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        fillMaterial: string | undefined;
        fillMaterialParams: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<any>;
        fillGround: boolean | undefined;
        imageShow: boolean | undefined;
        imageUrl: string | undefined;
        imageSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        imageAnchor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        imageOffset: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        textShow: boolean | undefined;
        textProperty: string | undefined;
        textDefaultText: string | undefined;
        textColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        textBackgroundColor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        textFontFamily: string | undefined;
        textFontSize: number | undefined;
        textFontStyle: number | undefined;
        textFontWeight: number | undefined;
        textAnchor: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        textOffset: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        minFeatureVisibleDistance: number;
        maxFeatureVisibleDistance: number;
        heightReference: string;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
}
export interface CzmGeoJson extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmGeoJson.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmGeoJson.createDefaultProps> & {
    type: string;
}>;
export {};
